HC = require 'hardoncollider'
lovebird = require 'gamedat/libraries/lovebird'
sti = require 'gamedat/libraries/sti'
lvl = require 'level'
anim8 = require 'gamedat/libraries/anim8'

function on_collide(dt, shape_a, shape_b)
	if shape_a == playerBox then
		Player:hitFloor()
	elseif shape_b == playerBox then
		Player:hitFloor()
	end
end

function love.load()
	Collider = HC(1200, on_collide)
	level.load()
	
	lovebird.updateinterval = 0.1
	font = love.graphics.newFont("OldLondon.ttf", 20)
	music = love.audio.newSource("8-bit loop.mp3")
	--music:play()
	
	-- Start of all things for the player
	
	require "Player"
	p = Player:new()
	player = love.graphics.newImage("gamedat/sprites/spritesheet.png")
	Player:load()
	
	playerBox = Collider:addRectangle(p.x, p.y, p.width - 10, p.height)
	playerBoxColor = {255,0,0}
	
	-- End of all things for the player
	
	-- require "bullet"
	-- b = bullet:new()
    -- b.bullets = {}
	-- b.startX = playerBox:center()
	-- b.startY = playerBox:center()         -- Uncomment this when you have a working bullet code!!
    -- b.bulletDx = 0
    -- b.bulletDy = 0
    -- b.ratio = 15
    -- b.bulletSpeedX = 5
    -- b.bulletSpeedY = 5
	-- b:load()
	
	-- Start of all things terrain
	
	terrainColor = {181,239,29}
	terrain = Collider:addRectangle(0, 579, 800, 32)
	tile = love.graphics.newImage("tileS.png")
	tiles = {}
	
	-- End of all things terrain
	
	back = love.graphics.newImage("background.png")
	backB = love.graphics.newImage("backgroundB.png") -- background Big
	
	boxON = true
	gravity = 800
end

function love.update(dt)
	--check for collisions
	Collider:update(dt)
	level.update()
	FPS = love.timer.getFPS()
	require("gamedat/libraries/lovebird").update()
	lovebird.clear()
	lovebird.print("FPS: " .. FPS)
	lovebird.print("X Pos: ".. p.x)
	lovebird.print("Y Pos: ".. p.y)
	lovebird.print(p.state)
	
	-- move left and right
	if love.keyboard.isDown("right") then
		p:moveRight()
	end
	if love.keyboard.isDown("left") then
		p:moveLeft()
	end
	
	if love.keyboard.isDown("x") or love.keyboard.isDown("up") then
		p:jump()
	end
	
	if love.keyboard.isDown("f1") then
		if boxON == false then
			boxON = true
		else
			boxON = false
		end
	end
	
	if p.x <= 0 then
		p.x = 800 - p.width
	elseif p.x >= 800 then
		p.x = 0
	end
	
	-- update the player's position
	p:update(dt, gravity)
	--b:update(dt) -- uncomment this when bullet code works
	
	--print(playerBox:center())
end

function love.draw()
	--love.graphics.draw(back, 0, 0)
	love.graphics.draw(backB, 0, 0)
	level.draw()
	Player:draw()
	love.graphics.print("Lovebird Enabled \n\n Port: " .. lovebird.port, 15,15)
	
	--b:draw() -- uncomment this when bullet code works
	
	love.graphics.setColor(playerBoxColor)
	if boxON == true then
		playerBox:draw("line")
	end
	
	love.graphics.setColor(0,0,0)
	love.graphics.setFont(font)
	
	love.graphics.setColor(255,0,0)
	terrain:draw("line")
	love.graphics.setColor(255,255,255)
end

function love.keyreleased(key)
	if key == "escape" or key == "-" then
		love.event.quit()
	end
	if (key == "right") or (key == "left") then
		p:stop()
	end
end

function DEBUG()
    love.graphics.print("FPS: ".. FPS, 20,20)
	love.graphics.print("X Pos: ".. p.x, 20,35)
	love.graphics.print("Y Pos: ".. p.y, 20,50)
	love.graphics.print(p.state, 20,65)
	love.graphics.print("Bullet StartX " .. b.startX, 20, 80)
	love.graphics.print("Bullet StartY " .. b.startY, 20, 95)
end